#define DEBUG

var	tickets/ticketSystem = new()
var	ticketBook = list()
var	ticketNames = list()

client/verb
	ticketMake()
		set name = "Make A Ticket"

		var	ticketTitle = input("Label","Ticket","None") as text
		while (!ticketTitle||ticketTitle == "None"||locate(ticketTitle) in ticketNames)
			ticketTitle = input("Label","Ticket","None") as text
		var	ticketMessage = input("Description","Ticket","None") as message
		while (!ticketMessage||ticketMessage == "None")
			ticketMessage = input("Description","Ticket","None") as message
		ticketSystem.submitTicket(src,ticketMessage,ticketTitle)

	ticketLook(var/obj/ticket/ticket in ticketBook)
		set name = "Look A Ticket"
		ticketSystem.readTicket(src,ticket)

	ticketUpdate(var/obj/ticket/ticket in ticketBook)
		set name = "Update A Ticket"
		ticketSystem.updateTicket(src,ticket)

	ticketDelete(var/obj/ticket/ticket in ticketBook)
		set name = "Delete A Ticket"
		ticketSystem.deleteTicket(src,ticket)

obj/ticket
	var	ticketMessage
	var	ticketUpdatedMessage
	var	ticketCreator
	var	ticketStatus

tickets/proc
	deleteTicket(client/client,obj/ticket/ticket)
		world << "[client] removed [ticket.ticketCreator]'s [ticket.name]([ticket.ticketStatus])"
		ticketNames -= ticket.name
		del ticket

	updateTicketContinue(var/command,obj/ticket/ticket,client/client)
		if(!command) return
		if(command == "Review")
			ticket.ticketStatus = "<font color = blue>Reviewing...</font>"
			var	ticketFeedback = input("Any Comments?","FeedBack","None") as message
			if	(!ticketFeedback||ticketFeedback == "None") ticketFeedback = "<font color = blue>[client.key] : No Additional Comments.</font>"
			ticket.ticketUpdatedMessage = "[ticket.ticketMessage]<br><font color = blue>[ticketFeedback]</font>"

		if(command == "Flag")
			ticket.ticketStatus = "<font color = red>Flagged!</font>"
			var	ticketFeedback = input("Explain why this Ticket was flagged:","FeedBack","None") as text
			while (!ticketFeedback||ticketFeedback == "None")
				ticketFeedback = input("Explain why this Ticket was flagged:","FeedBack","None") as text
			ticket.ticketUpdatedMessage = "[ticket.ticketMessage]<br><font color = red>[client.key] : [ticketFeedback]</font>"

		if(command == "Solve")
			ticket.ticketStatus = "<font color = green>Solved!</font>"
			var	ticketFeedback = input("Explain how this Ticket was solved:","FeedBack","None") as text
			while (!ticketFeedback||ticketFeedback == "None")
				ticketFeedback = input("Explain how this Ticket was solved:","FeedBack","None") as text
			ticket.ticketUpdatedMessage = "[ticket.ticketMessage]<br><font color = green>[client.key] : [ticketFeedback]</font>"

	updateTicket(client/client,obj/ticket/ticket)
		switch(alert(client,"Command?","Update","Review","Flag","Solve"))
			if	("Review")	ticketSystem.updateTicketContinue("Review",ticket,client)
			if	("Flag")	ticketSystem.updateTicketContinue("Flag",ticket,client)
			if	("Solve")	ticketSystem.updateTicketContinue("Solve",ticket,client)

	submitTicket(client/client,title,message)
		var/obj/ticket/ticket = new /obj/ticket
		ticket.ticketCreator = "[client.key]"
		ticket.ticketMessage = message
		ticket.ticketStatus = "Submitted"
		ticket.name = title
		ticketBook += ticket
		ticketNames += ticket.name

	readTicket(client/client,obj/ticket/ticket)
		client << "[ticket.name]([ticket.ticketStatus]) by [ticket.ticketCreator]"
		client << "<br>"
		if	(ticket.ticketUpdatedMessage) client << ticket.ticketUpdatedMessage
		else client << ticket.ticketMessage